<template>
  <Page>
    <ActionBar class="action" title="Login Octanium MTTO!"/>
    <FlexboxLayout class="page">
        <StackLayout class="form">
          <Image class="logo" src="~/assets/images/logo.png" />

          <StackLayout class="input-field" marginBottom="25">
            <TextField class="input" hint="E-mail" keyboardType="email" autocorrect="false" autocapitalizationType="none" v-model="user.email"
            returnKeyType="next" @returnPress="focusPassword" fontSize="18" />
            <StackLayout class="hr-light" />
          </StackLayout>

          <StackLayout class="input-field" marginBottom="25">
            <TextField ref="password" class="input" hint="Password" secure="true" v-model="user.password" returnKeyType="done"
            fontSize="18" />
            <StackLayout class="hr-light" />
          </StackLayout>

          <Button v-show="!processing" text="Log In" @tap="submit" class="btn btn-primary m-t-20" />
          <Label text="Olvidaste tu contraseña?" class="login-label" @tap="forgotPassword" />
          <ActivityIndicator :busy="processing" color="#7d00cc"></ActivityIndicator>
        </StackLayout>
		</FlexboxLayout>
  </Page>
</template>

<script>
import ListPage from "./ListPage";
import axios from "axios";
import {urlApi} from "../main.js";
import store from '../store';

export default {
  data() {
    return {
      processing: false,
      user: {
        email: "esteban.lopez@gmail.com",
        password: "superA"
      }
    };
  },
  methods: {
    submit() {
      if (!this.user.email || !this.user.password) {
        this.alert(
          "Provee ambos un email y contraseña."
        );
        return;
      }
      this.login();
    },

    login() {
      this.processing = true;
      this.$store.dispatch('login', this.user)
        .then(() => {
          this.$store.dispatch('setUser', this.user)
          .then(()=>{
            this.processing = false;
            this.$navigateTo(ListPage);
          });
        })
        .catch(() => {
          this.processing = false;
          this.alert("E-mail o password incorrectos");
        });
    },

    forgotPassword() {
        prompt({
          title: "Recuperar password",
          message: "Escribe la direccion e-mail que usaste para registrarte en el sistema Octanium.",
          inputType: "e-mail",
          defaultText: "",
          okButtonText: "Restablecer",
          cancelButtonText: "Cancelar"
        }).then(data => {
          store.dispatch('resetPassword',data.text)
          .then((response) => {
            this.alert(
              response.data.message
            );
          })
          .catch(() => {      
            this.alert(
              "Es posible que haya ocurrido un error restableciendo su password o haya proporcionado un email no valido."
            );
          });  
        });
    },

    focusPassword() {
      this.$refs.password.nativeView.focus();
    },

    alert(message) {
      return alert({
        title: "Login Ocatnium MTTO!",
        okButtonText: "OK",
        message: message
      });
    }
}
}
</script>

<style scoped>
.page {
  align-items: center;
  flex-direction: column;
  background-image: none;
  color: #490d66;
}

.form {
  margin-left: 30;
  margin-right: 30;
  flex-grow: 2;
  vertical-align: middle;
}

.logo {
  margin-bottom: 12;
  height: 200;
  font-weight: bold;
}

.input-field {
  margin-bottom: 25;
}

.input {
  font-size: 18;
  placeholder-color: #ffffff;
}

.input-field .input {
  font-size: 54;
}

.btn-primary {
  height: 50;
  margin: 30 5 15 5;
  background-color: #7d00cc;
  border-radius: 5;
  font-size: 20;
  font-weight: 600;
}

.login-label {
  horizontal-align: center;
  color: #490d66;
  font-size: 16;
}
</style>
